"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Container = void 0;
var Container = /** @class */ (function () {
    function Container() {
    }
    Container.instantiateService = function (provider) {
        var _a;
        var _this = this;
        var _b;
        var resolvedDependencies = [];
        if (provider.dependencies !== undefined) {
            provider.dependencies.forEach(function (dependency) { return resolvedDependencies.push(_this.resolve(dependency)); });
        }
        return new ((_a = provider.service).bind.apply(_a, __spreadArrays([void 0], ((_b = provider.constructorParams) !== null && _b !== void 0 ? _b : []), resolvedDependencies)))();
    };
    Container.findProvider = function (service) {
        return this.providers.find(function (provider) { return provider.service.name === service.name; });
    };
    Container.isProviderAlreadyRegistered = function (service) {
        return this.providers.findIndex(function (provider) { return provider.service.name === service.name; }) !== -1;
    };
    Container.addProvider = function (provider) {
        if (this.isProviderAlreadyRegistered(provider.service)) {
            return;
        }
        this.providers.push(provider);
    };
    Container.registerProviders = function (providers) {
        providers.forEach(this.addProvider.bind(this));
    };
    Container.resolve = function (service) {
        var provider = this.findProvider(service);
        if (provider === undefined) {
            throw Error("requested dependency to be resolved is not registered in any provider!");
        }
        if (provider.instance === undefined) {
            provider.instance = this.instantiateService(provider);
        }
        if (!provider.asSingleton) {
            if (provider.isConsumed) {
                provider.instance = this.instantiateService(provider);
            }
            else {
                provider.isConsumed = true;
            }
        }
        return provider.instance;
    };
    Container.providers = [];
    return Container;
}());
exports.Container = Container;
